
void setController(){
  controlP5 = new ControlP5(this);
  controlP5.setAutoDraw(false);
  
  controlP5.addToggle("hunger_display",true,215,100,20,10).setMode(ControlP5.SWITCH);
  controlP5.addSlider("hunger_x", 1, 40, hunger_x, 10, 100, 150, 10);
  controlP5.addSlider("hunger_y", 1, 40, hunger_y, 10, 112, 150, 10);
  controlP5.addToggle("sub_display",false,width-70,10,20,10).setMode(ControlP5.SWITCH);

  controlP5.addSlider("SPRING_STRENGTH", 0, 100, SPRING_STRENGTH, 10, 20, 150, 10);
  controlP5.addSlider("SPRING_DAMPING", 0, 100, SPRING_DAMPING, 10, 32, 150, 10);
  controlP5.addSlider("Cloth_x", 0, 100, Cloth_x, 10, 60, 150, 10);
  controlP5.addSlider("Cloth_y", 0, 100, Cloth_y, 10, 72, 150, 10);
  
  controlP5.addBang("resize_cloth", 215, 60, 20, 20);
}

void keyPressed() {
  switch(key) {
  case 'u':
    //    setCurrentParticle(); 
    currentParticle.position.set(currentParticle.position.x(), currentParticle.position.y()+1, currentParticle.position.z()); 
    break;
  case 'd': 
    //    setCurrentParticle(); 
    currentParticle.position.set(currentParticle.position.x(), currentParticle.position.y()-1, currentParticle.position.z()); 
    break;
  case 'r':
    //    setCurrentParticle(); 
    currentParticle.position.set(currentParticle.position.x()+1, currentParticle.position.y(), currentParticle.position.z()); 
    break;
  case 'l': 
    //    setCurrentParticle(); 
    currentParticle.position.set(currentParticle.position.x()-1, currentParticle.position.y(), currentParticle.position.z()); 
    break;
  case 'x': 
    setCurrentParticle();
    currentParticle.makeFixed();
    break;
  case 'f': 
    setCurrentParticle();
    currentParticle.makeFree();
    break;
  case 'k': 
    setCurrentParticle();
    currentParticle.dead = true;
    physics.removeParticle(currentParticle);
    physics.removeParticle(currentParticle);
    physics.removeParticle(currentParticle);
    break;
  case 'z': 
    //    setCurrentParticle();
    currentParticle.position.set(currentParticle.position.x(), currentParticle.position.y(), currentParticle.position.z()+10); 
    break;
  case 'w': 
    //    setCurrentParticle();
    currentParticle.position.set(currentParticle.position.x(), currentParticle.position.y(), currentParticle.position.z()-10); 
    break;
  case 'h':
    if(hunger_display) hunger_display = false;
    else hunger_display = true;
    break;
  case 's':
    if(startSim) startSim = false;
    else startSim = true;
    break;
  case '@':
    //    setFaces();
    setQuads();
    break;
  
    case '/':
 if(signOfHunger2) signOfHunger2 = false;
    else signOfHunger2 = true;
    break;
    
    case '^':
 if(isFaces) isFaces = false;
    else isFaces = true;
    break;
    
  case 'a': 
    anchor[anchornum] = currentParticle.id;
    anchornum = anchornum + 1;
    break;
  case ':':
    force[forcenum] = currentParticle.id;
    forcenum = forcenum + 1;
    break;
  }

  switch(keyCode) {
  case UP: 
    expo = expo + 0.05;
    break;
  case DOWN: 
    expo = expo - 0.05;
    break;
  }
}

void mouseClicked() {
  if(mouseY > 200) setCurrentParticle();
}

void mouseDragged() {
  if(mouseY>200 || mouseX > 300){
  rotx = rotx + (mouseY - pmouseY) * rate;
  roty = roty + (mouseX - pmouseX) * rate;
  }
  setSpring();
}

